// coding: utf-8
/*! Created by: Udo Schmal | https://www.gocher.me/ */
(function () {
  'use strict';
  function Pages(pageslist) {
    var store =  pageslist.dataset.store === 'true';
    if (store) {
      store = 'pages-' + window.location.pathname;
    }
    var self = pageslist;
    var current = 0;
    var pages = pageslist.children;
    var maxlength = 5;
    var previous, next, placeholderPrevious, placeholderNext;
    var pagination = [];
    // load stylesheet
    if (!document.getElementById('pages.css')) {
      var style = document.createElement("link");
      style.type = 'text/css';
      style.href = '/code/pagination/pages.css';
      style.id = 'pages.css';
      style.rel = 'stylesheet';
      document.head.appendChild(style);
    }
    // create page browser
    var navi = document.createElement("ul");
    navi.className = "paginator";
    pageslist.parentNode.insertBefore(navi, pageslist.nextSibling);
    function updateBefore() {
      pagination[current].classList.remove("active");
      pages[current].classList.remove("active");
    }
    function updateAfter() {
      if (pages.length > 5) {
        if (current == 0) {
          previous.classList.add('hidden');
        } else {
          previous.classList.remove('hidden');
        }
        if (current < 4) {
          placeholderPrevious.classList.add('none');
        } else {
          placeholderPrevious.classList.remove('none');
        }
        if (current < 2) {
          for (var i=1; i < pages.length-1; i++) {
            if (i > 4) {
              pagination[i].classList.add('none');
            } else {
              pagination[i].classList.remove('none');
            }
          }
        } else if (current > pages.length-3) {
          for (var i=1; i < pages.length-1; i++) {
            if (i < pages.length-5) {
              pagination[i].classList.add('none');
            } else {
              pagination[i].classList.remove('none');
            }
          }
        } else {
          for (var i=1; i < pages.length-1; i++) {
            if ((i < current-2) || (i > current+2)) {
              pagination[i].classList.add('none');
            } else {
              pagination[i].classList.remove('none');
            }
          }
        }
        if (current > pages.length-5) {
          placeholderNext.classList.add('none');
        } else {
          placeholderNext.classList.remove('none');
        }
        if (current == pages.length-1) {
          next.classList.add('hidden');
        } else {
          next.classList.remove('hidden');
        }
      }
      pagination[current].classList.add("active");
      pages[current].classList.add("active");
      if (store) {
        sessionStorage.setItem(store, current);
      }
      self.scrollIntoView();
    }
    function btn(event) {
      updateBefore();
      if (this.classList.contains('previous')) {
        current = current > 0 ? current - 1 : 1;
      } else {
        current = current < pages.length-1 ? current + 1 : pages.length-1;
      }
      updateAfter();
      event.stopPropagation();
    }
    function toggle(event) {
      updateBefore();
      current = this.pageid;
      updateAfter();
      event.stopPropagation();
    }
    if (pages.length > 5) {
      previous = document.createElement("li");
      previous.className = 'previous';
      previous.addEventListener('mousedown', btn);
      navi.appendChild(previous);
    }
    var item;
    for (var i=0; i<pages.length; i++) {
      if (pages[i].classList.contains("active")) {
        current = i;
      };
      item = document.createElement("li");
      item.appendChild(document.createTextNode(i+1));
      item.pageid = i;
      navi.appendChild(item);
      item.addEventListener('mousedown', toggle);
      pagination.push(item);
      if (pages.length > 5) {
        if (i==0) {
          placeholderPrevious = document.createElement("li");
          placeholderPrevious.className = 'placeholder';
          navi.appendChild(placeholderPrevious);
        }
        if (i==pages.length-2) {
          placeholderNext = document.createElement("li");
          placeholderNext.className = 'placeholder';
          navi.appendChild(placeholderNext);
        }
      }
    }
    if (pages.length > 5) {
      next = document.createElement("li");
      next.className = 'next';
      next.addEventListener('mousedown', btn);
      navi.appendChild(next);
    }
    if (store && sessionStorage.getItem(store)) {
      current = sessionStorage.getItem(store);
    }
    updateAfter();
  }
  var pagesList = document.querySelectorAll("ul.pages");
  for (var i=0; i<pagesList.length; i++) {
    new Pages(pagesList[i]);
  }
})();
